code	segment	'code'
	assume	cs:code,ds:code

	org	2ch
envseg	label	word			; pointer to environment segment

	org	100h
start:	jmp	near ptr init		; jump to install routine
	dw	0

new2f:	cmp	ax,1510h		; device driver request?
	jne	start
	cmp	byte ptr es:[bx+2],3	; IOCTL input?
	jne	start

	push	es
	push	bx
	les	bx,es:[bx+0eh]		; get buffer pointer
	cmp	byte ptr es:[bx],0ch	; audio sub channel data?
	jne	exit

	push	cx			; eat some cycles in a loop
	xor	cx,cx
	sti				; enable interrupts
wloop:
	db	24 dup (90h)		; bunch of NOPs
	loop	wloop
	pop	cx

exit:	pop	bx
	pop	es

	jmp	short start		; jump to old handler

init:	mov	ax,352fh		; create jump to old INT 2F handler
	int	21h
	inc	byte ptr start
	mov	word ptr start+1,bx
	mov	word ptr start+3,es

	mov	dx,offset new2f		; install new INT 2F handler
	mov	ah,25h
	int	21h

	mov	es,envseg		; free environment segment
	mov	ah,49h
	int	21h

	mov	dx,0014h		; terminate leaving DX para resident
	mov	ax,3100h
	int	21h

code	ends

	end	start
